
module FFJ.Test where {
	import FFJ.Syntax;
	import FFJ.Parser;
	import FFJ.Adapter;
	import FFJ.Program;
	import FFJ.Print;
	import FFJ.AuxFunc;
	import FFJ.Semantics;
	import FFJ.Typing;
	import Maybe;

	parse :: String -> [PStat];
	parse = parser . lexer;
	
	ft = [("Pair","Base"),("A","F1"),("B","F2"),("C","F3")];
	
	main = do {
		x <- readFile "FFJ/test/Base/Pair.ffj";
		let {y = parse x;};
		let {(ctbase,ptbase) = getFeature (initct,initpt) "Base" y;};
		
		x <- readFile "FFJ/test/F1/Pair.ffj";
		let {y = parse x;};
		let {(ctf1,ptf1) = getFeature (ctbase,ptbase) "F1" y;};
		
		x <- readFile "FFJ/test/F2/Pair.ffj";
		let {y = parse x;};
		let {(ctf2,ptf2) = getFeature (ctf1,ptf1) "F2" y;};
		
		x <- readFile "FFJ/test/F3/Pair.ffj";
		let {y = parse x;};
		let {(ctf3,ptf3) = getFeature (ctf2,ptf2) "F3" y;};
		
		printct ctf3;
		putStr ("\n\n" ++ "Source Programs:\n\n");
		printpt ptf3;
		putStr ("\n\n" ++ "Source Programs (variables substituted):\n\n");
		let {ptf3subst = (substpt ptf3);};
		printpt ptf3subst;
		if (allOK ctf3 ptf3subst) == False then error "Class table or programs are not well-formed!" else putStr "";
		let { eptf3 = evalpt ctf3 ptf3subst; };
		putStr ("\n\n" ++ "Evaluated Programs:\n\n");
		printpt eptf3;
	};
	

}
