module FFJPL.Navigation where {
	import FFJ.Syntax;
	import FFJPL.Definitions;

	getPred :: CT -> ExtType -> ExtType;
	getPred ct (c,phi) = case (getPredInner ct [] (c,phi)) of {
		Just pre -> pre;
		Nothing -> ("Object","Base");
	};

	getPredInner :: CT -> [ExtType] -> ExtType -> Maybe ExtType;
	getPredInner (((d,psi),_):xs) prevtypes (c,phi) 
		| ((d == c) && (psi == phi)) = if ((length prevtypes) == 0) 
		                               then Nothing 
		                               else Just (head prevtypes)
		| ((d == c ) && (psi /= phi)) = getPredInner xs ((d,psi):prevtypes) (c,phi)
		| otherwise = getPredInner xs prevtypes (c,phi);
	getPredInner [] prevtypes (c,phi) = error ("Class (" ++ c ++ "," ++ phi ++ ") not found in class table! (getPredInner)!");
    
    getLast :: CT -> Type -> ExtType;
    getLast ct c = getLastInner ct [] c;
    
    getLastInner :: CT -> [ExtType] -> Type -> ExtType;
    getLastInner (((d,psi),_):xs) prevtypes c 
		| (d == c) = getLastInner xs ((d,psi) : prevtypes) c
		| otherwise = getLastInner xs prevtypes c;
    getLastInner [] prevtypes c 
		| ((length prevtypes) == 0) = error ("Class " ++ c ++ " not found in class table! (getLastInner)!")
		| otherwise = (head prevtypes);
}