
module FJ.AuxFunc where  {
	import FJ.Syntax;
	import FJ.Program;
	import Maybe;
	
	fields :: CT -> Type -> [Field];
	fields ct c = case (classdef ct c) of {
		Just (c,d,k,fs,ms) -> (fields ct d) ++ fs;
		Nothing -> [];
	};
	
	getFieldType :: Identifier -> [Field] -> Type;
	getFieldType f ((c,g):gs) | (f == g) = c
	                          | otherwise = (getFieldType f gs);
	getFieldType f [] = error ("Error :field " ++ f ++ " does not exist!");
	
	mtype :: CT -> Identifier -> Type -> Maybe Signature;
	mtype ct m c = case (classdef ct c) of {
		Just (c,d,k,fs,ms) -> case mdef m ms of {
			Just (r,n,ps,b) -> Just (fst (unzip ps),r);
			Nothing -> mtype ct m d;
		};
		Nothing -> Nothing;
	};
	
	mdef :: Identifier -> [Method] -> Maybe Method;
	mdef n ((r,m,ps,b):xs) | (m == n) = Just (r,m,ps,b) | otherwise = mdef n xs;
	mdef n [] = Nothing;
	
	mbody :: CT -> Identifier -> Type -> Maybe MethodBody;
	mbody ct m c = case (classdef ct c) of {
		Just (c,d,k,fs,ms) -> case mdef m ms of {
			Just (r,n,ps,b) -> Just (snd (unzip ps),b);
			Nothing -> mbody ct m d;
		};
		Nothing -> Nothing;
	};

	overrideType :: CT -> Identifier -> Type -> Signature -> Bool;
	overrideType ct m c (ps, r) | (isJust (mtype ct m c)) = (ps == (fst (fromJust (mtype ct m c))) && r == (snd (fromJust (mtype ct m c)))) | otherwise = True;
	
	overrideClass :: CT -> Identifier -> Class -> Signature -> Bool;
	overrideClass ct m (c,_,_,_,_) sgn = overrideType ct m c sgn;
}