
module FJ.Syntax where {

	type Identifier = String;
	type Type = Identifier;
	type Variable = Identifier;
	type Class = (Identifier, Type, Cons, [Field], [Method]);
	type Field = (Type, Identifier);
	type Method = (Type, Identifier, [Param], Term);
	type Cons = (Identifier, [Param], [Variable], [(Variable,Variable)]);
	type Param = (Type, Variable);
	type MethodBody = ([Variable], Term);
	type Signature = ([Type], Type);

	data Term = Var Variable | Proj Term Identifier | Inv Term Identifier [Term] | Inst Type [Term] | Cast Type Term deriving Show;
}